package cpcns.dingZhi.zhuanYeAnJuan.service.impl;

package .tmp;

import cpcns.baoguanqixiancelue.service.IGQuanZongWeiHuService;
import cpcns.base.common.User;
import cpcns.base.configuration.AppConfiguration;
import cpcns.dangAnBase.base.service.impl.DangAnBaseServiceImpl;
import cpcns.dingZhi.zhuanYeAnJuan.dao.IZhuanYeAnJuanDao;
import cpcns.dingZhi.zhuanYeAnJuan.model.zhuanYeAnJuan;
import cpcns.dingZhi.zhuanYeAnJuan.service.IZhuanYeAnJuanService;
import cpcns.utils.CommStatic;
import cpcns.utils.PagerVO;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("zhuanYeAnJuanService")
public class ZhuanYeAnJuanServiceImpl extends DangAnBaseServiceImpl<zhuanYeAnJuan> implements IZhuanYeAnJuanService {
  @Autowired
  private IZhuanYeAnJuanDao zhuanYeAnJuanDao;
  
  @Autowired
  private IGQuanZongWeiHuService quanZongWeiHuService;
  
  public PagerVO query_SQL(User user, Integer start, Integer rows, String table, Map<String, Object> map, String orderbysql) throws Exception {
    Map<String, Object> tp = new HashMap<>();
    StringBuffer sql = (new StringBuffer(" select hangBiaoShi,biaoTi,quanZongHao,guiDangNianDu,baoGuanQiXian,muLuHao,cunFangWeiZhi,danWeiMingCheng,shanChuRenMingCheng,sanJiFenLeiMingCheng,dangHao,xuHao from ")).append(table).append(" where 1=1 and zhuangTai not in(:zhuangTai)");
    tp.put("zhuangTai", new String[] { "3", "4" });
    boolean fl = getInitVal("chaXunQuanXianKongZhi", "chaXunQuanXianKongZhi");
    if (fl) {
      Map<String, String> tjmap = new HashMap<>();
      String quanZongHao = (String)map.get("quanZongHao");
      String checkbox = (map.get("checkbox") == null) ? "false" : (String)map.get("checkbox");
      String all_qz = this.quanZongWeiHuService.getAllQzuanZhong(user.getQuanZongHao());
      tjmap.put("guanLianQuanZong", all_qz);
      tjmap.put("checkbox", checkbox);
      tjmap.put("quanZongHao", quanZongHao);
      tjmap.put("table", table);
      sql.append(CommStatic.IsQuanXian(user, AppConfiguration.getConfigValue("CPCNS_XITONGLEIXING"), tjmap));
    } 
    Object para = null;
    para = map.get("querystr");
    if (para != null && para != "") {
      Object menLei = map.get("menLei");
      if (menLei != null && menLei != "") {
        sql.append(" and menLei =:menLei");
        tp.put("menLei", menLei);
      } 
      CommStatic.zhuHeQueryJieXi_map(sql, tp, para.toString(), (String)map.get("zuHeType"), getDataType());
    } else {
      para = map.get("biaoTi");
      if (para != null && para != "") {
        sql.append(" and biaoTi like :biaoTi");
        tp.put("biaoTi", "%" + para + "%");
      } 
      para = map.get("guiDangNianDu");
      if (para != null && para != "") {
        tp.put("guiDangNianDu", para);
        para = map.get("guiDangNianDu_Operator");
        if (para != null && para != "") {
          sql.append(" and guiDangNianDu ").append(para).append(":guiDangNianDu");
        } else {
          sql.append(" and guiDangNianDu ").append("=:guiDangNianDu");
        } 
      } 
      para = map.get("muLuHao");
      if (para != null && para != "") {
        sql.append(" and muLuHao=:muLuHao");
        tp.put("muLuHao", para);
      } 
      para = map.get("cunFangWeiZhi");
      if (para != null && para != "") {
        sql.append(" and cunFangWeiZhi=:cunFangWeiZhi");
        tp.put("cunFangWeiZhi", para);
      } 
      para = map.get("dangHao");
      if (para != null && para != "") {
        sql.append(" and dangHao=:dangHao");
        tp.put("dangHao", para);
      } 
      para = map.get("menLei");
      if (para != null && para != "") {
        sql.append(" and menLei=:menLei");
        tp.put("menLei", para);
      } 
    } 
    return this.zhuanYeAnJuanDao.querySQL(start, rows, sql.toString(), tp, orderbysql);
  }
  
  public List<Map<String, Object>> getDate(String table, Map<String, Object> map, User user) {
    Map<String, Object> tp = new HashMap<>();
    StringBuffer sql = null;
    if (StringUtils.isNotBlank((String)map.get("menLei")) && "TDCGWS".equals(map.get("menLei"))) {
      sql = (new StringBuffer(" select wj.hangBiaoShi,wj.biaoTi,wj.quanZongHao,wj.guiDangNianDu,wj.muLuHao,wj.cunFangWeiZhi,wj.dangHao,wj.fenLeiMingCheng,wj.fenLeiHao,wj.zeRenZhe,wj.anJuanHao,wj.liJuanDanWeiMingCheng,wj.beiZhu,wj.xuHao from ")).append(table).append(" wj where 1=1 and wj.zhuangTai not in(:zhuangTai)");
    } else {
      sql = (new StringBuffer(" select wj.hangBiaoShi,wj.biaoTi,wj.quanZongHao,wj.guiDangNianDu,wj.muLuHao,wj.cunFangWeiZhi,wj.dangHao,wj.fenLeiMingCheng,wj.fenLeiHao,wj.zeRenZhe,wj.anJuanHao,wj.liJuanDanWeiMingCheng,wj.beiZhu from ")).append(table).append(" wj where 1=1 and wj.zhuangTai not in(:zhuangTai)");
    } 
    pinjieSql(sql, tp, map);
    return this.zhuanYeAnJuanDao.getListMap(sql.toString(), tp);
  }
  
  private void pinjieSql(StringBuffer sql, Map<String, Object> tp, Map<String, Object> map) {
    Object importExcelTool = map.get("importTool");
    if (StringUtils.isNotBlank((String)importExcelTool)) {
      if (importExcelTool.equals("importTool"))
        tp.put("zhuangTai", new String[] { "6", "6" }); 
    } else {
      tp.put("zhuangTai", new String[] { "3", "4", "6" });
    } 
    Object para = null;
    para = map.get("querystr");
    if (para != null && para != "") {
      Object menLei = map.get("menLei");
      if (menLei != null && menLei != "") {
        sql.append(" and wj.menLei =:menLei");
        tp.put("menLei", menLei);
      } 
      CommStatic.zhuHeQueryJieXi_map(sql, tp, para.toString(), (String)map.get("zuHeType"), getDataType());
    } else {
      para = map.get("hbs");
      if (para != null && para != "") {
        sql.append(" and wj.hangbiaoshi in(:hangbiaoshi)");
        tp.put("hangbiaoshi", para.toString().split(","));
      } else {
        para = map.get("biaoTi");
        if (para != null && para != "") {
          sql.append(" and wj.biaoTi like :biaoTi");
          tp.put("biaoTi", "%" + para + "%");
        } 
        para = map.get("quanZongHao");
        if (para != null && para != "") {
          sql.append(" and wj.quanZongHao=:quanZongHao");
          tp.put("quanZongHao", para);
        } 
        para = map.get("guiDangNianDu");
        if (para != null && para != "") {
          tp.put("guiDangNianDu", para);
          para = map.get("guiDangNianDu_Operator");
          if (para != null && para != "") {
            sql.append(" and wj.guiDangNianDu ").append(para).append(":guiDangNianDu");
          } else {
            sql.append(" and wj.guiDangNianDu ").append("=:guiDangNianDu");
          } 
        } 
        para = map.get("muLuHao");
        if (para != null && para != "") {
          sql.append(" and wj.muLuHao=:muLuHao");
          tp.put("muLuHao", para);
        } 
        para = map.get("cunFangWeiZhi");
        if (para != null && para != "") {
          sql.append(" and wj.cunFangWeiZhi=:cunFangWeiZhi");
          tp.put("cunFangWeiZhi", para);
        } 
        para = map.get("dangHao");
        if (para != null && para != "") {
          sql.append(" and wj.dangHao=:dangHao");
          tp.put("dangHao", para);
        } 
      } 
      para = map.get("menLei");
      if (para != null && para != "") {
        sql.append(" and wj.menLei=:menLei");
        tp.put("menLei", para);
      } 
      sql.append(" order by hangbiaoshi");
    } 
  }
}
